package com.bonait.bnframework.modules.home.adapter;

import android.app.Activity;
import android.content.Context;
import android.content.ContextWrapper;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.ProgressBar;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.bonait.bnframework.R;
import com.bonait.bnframework.business.ExecuteTheRecipe;
import com.bonait.bnframework.common.constant.DataBus;
import com.bonait.bnframework.common.db.res.SilosLsjyMode;
import com.bonait.bnframework.common.helper.I.IWriteCallBack;
import com.bonait.bnframework.common.utils.ToastUtils;
import com.suke.widget.SwitchButton;

import java.util.List;

/**
 * 流速校验
 */
public class lsjy_adapter extends RecyclerView.Adapter<RecyclerView.ViewHolder> {

    private final LayoutInflater mLayoutInflater;

    private Context context;

    public List<SilosLsjyMode> mainGoods = DataBus.getInstance().SilosLsjy;

    public lsjy_adapter(Context context) {
        this.context = context;
        mLayoutInflater = LayoutInflater.from(context);
    }

    @NonNull
    @Override
    public RecyclerView.ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        View inflate = mLayoutInflater.inflate(R.layout.lsjy_item, parent, false);
        return new MyGoodLCViewHolder(inflate);

    }

    @Override
    public void onBindViewHolder(@NonNull RecyclerView.ViewHolder holder, int position) {
        try {
            if (holder instanceof MyGoodLCViewHolder) {
                MyGoodLCViewHolder myViewHolder = (MyGoodLCViewHolder) holder;
                SilosLsjyMode goodsMake= mainGoods.get(position);
                String name= "通道"+goodsMake.num+"(" +goodsMake.name+")";
                myViewHolder.name.setText(name+"");
                myViewHolder.wlname.setText(goodsMake.materialName+"");
               // myViewHolder.edittext_xs.setText(goodsMake.xs+"");
                myViewHolder.control_switch.setChecked(goodsMake.jzkg);
                myViewHolder.edittext_tdzl.setText(goodsMake.Value+"");

                myViewHolder.control_switch.setOnCheckedChangeListener(new SwitchButton.OnCheckedChangeListener() {
                    @Override
                    public void onCheckedChanged(SwitchButton view, boolean isChecked) {
                        //boolean ischick= myViewHolder.control_switch.isChecked();
                        DataBus.getInstance().SilosLsjy.get(position).jzkg=isChecked;
                        ExecuteTheRecipe.WritePLC("通道" + goodsMake.num+"校准开关", isChecked, null);
                        //goodsMake.jzkg=ischick;
                        //notifyDataSetChanged();
//                        ExecuteTheRecipe.WritePLC("通道1校准开关",ischick,null);
//                        ToastUtils.info("写入地址:"+model.address+"成功！状态:"+(ischick?"打开":"关闭"));
                    }
                });

                myViewHolder.save_value.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View view) {
                        String value = myViewHolder.edittext_tdzl.getText().toString();
                        //String value1=myViewHolder.edittext_xs.getText().toString();
                        Short val = 0;
                        //float xs= 1.0F;
                        try {
                            val = (short) Math.round((Double.parseDouble(value) * 10));
                            //xs=Float.parseFloat(value1);
                        } catch (Exception e) {
                        }

                        //ExecuteTheRecipe.WritePLC("出料系数"+goodsMake.num,xs,null);
                        ExecuteTheRecipe.WritePLC("校准值" + goodsMake.num, val, new IWriteCallBack() {
                            @Override
                            public void onSuccess() {
                                ToastUtils.info(name+"保存成功！");
                            }

                            @Override
                            public void onFailure(String ErrorMsg) {
                                ToastUtils.error(name+"保存失败！");
                            }
                        });

                    }
                });
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    private Activity findActivity(@NonNull Context context) {
        if (context instanceof Activity) {
            return (Activity) context;
        } else if (context instanceof ContextWrapper) {
            return findActivity(((ContextWrapper) context).getBaseContext());
        } else {
            return null;
        }
    }
    /**
     * 刷新
     * @param
     */
    public void refresh(){
        Activity activity= findActivity(context);
        if(activity!=null)
        {
            activity.runOnUiThread(new Runnable() {
                @Override
                public void run() {
                    try {
                        notifyDataSetChanged();
                    } catch (Exception e) {

                    }
                }
            });
        }
    }

    @Override
    public int getItemCount() {
        return mainGoods.size();
    }

    public static class MyGoodLCViewHolder extends RecyclerView.ViewHolder {
        /**
         * 通道名称
         */
        TextView name;
        /**
         * 物料名称
         */
        TextView wlname;
        /**
         * 系数
         */
        //EditText edittext_xs;
        /**
         * 校准开关
         */
        SwitchButton control_switch;
        /**
         * 通道重量
         */
        EditText edittext_tdzl;
        /**
         * 保存值
         */
        Button save_value;
        public MyGoodLCViewHolder(View view) {
            super(view);
            name = (TextView) view.findViewById(R.id.name);
            wlname = (TextView) view.findViewById(R.id.wlname);
           // edittext_xs=(EditText) view.findViewById(R.id.edittext_xs);
            control_switch = (SwitchButton)view.findViewById(R.id.control_switch);
            edittext_tdzl=(EditText) view.findViewById(R.id.edittext_tdzl);
            save_value=(Button) view.findViewById(R.id.save_value);
        }
    }
}
